
<p>
    {{> theorie }}
    Wenn eine Datenbank aufgesetzt und mit Daten gefüllt wird, dann ist davon auszugehen, dass
    diese Datenbank über einen langen Zeitraum, Jahre, vielleicht
    <img style="max-width: 18em; margin-left: 1em; margin-top: 1em;" class="ovk-float-right"
        src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Datenbanken.svg" alt=''
        id="er-diagramm" />
    sogar Jahrzehnte in Gebrauch ist. Die Anwendungen, die auf sie zugreifen, können sich
    über die Zeit ändern, auch können neue Anwendungen hinzu kommen.
</p>
<p>Die Datenbank soll dabei von den Anwendungen <span class="bold">entkoppelt</span> sein, d. h. bei
    einer Änderung einer Anwendung soll die Datenbank nicht geändert werden müssen.
    Wir sprechen auch von <span class="bold">Anwendungsunabhängigkeit</span>. Dies ist auch unseren
    Geschäftsleuten vom Limo-Shop wichtig:
</p>
<div class="card ovk-story">
    <div class="card-body schon-gewusst-body">
        <p>
            <img style="max-width: 20em;" class="ovk-float-right"
                src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/smartphone.svg" alt=''
                id="er-diagramm" />
            Die Webseite ist ein Erfolg und nun soll der Limo-Shop auch über eine mobile App
            für das Smartphone erreichbar sein.<br />
            <img style="max-width: 14em;" class="ovk-float-left"
                src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/bar.svg" alt=''
                id="er-diagramm" />
            Gleichzeitig wünscht ein Großhändler der Region eine Möglichkeit, die Produkte des Shops in
            das eigene Sortiment automatisiert einzubinden. Hierfür müssen Schnittstellen geschaffen
            werden. Dabei sollen möglichst wenige Änderungen an der Datenbank vorgenommen werden, damit
            die existierende Webseite nicht &bdquo;kaputt geht&ldquo; und weiterhin für Bestellungen
            verwendet werden kann.
        </p>
        <p>
            Anwendungsunabhängigkeit bedeutet, dass unsere Datenbank von diesen Änderungen entkoppelt
            ist.
        </p>
    </div>
</div>
<br />
<p>
    {{> theorie }}
    Viele verschiedene relationale Datenbanksysteme sind auf dem Markt erhältlich, darunter
    <a href="https://de.wikipedia.org/wiki/Db2">IBM DB2</a>, <a
        href="https://de.wikipedia.org/wiki/Microsoft_SQL_Server">Microsoft SQL Server</a>,
    <a href="https://de.wikipedia.org/wiki/PostgreSQL">PostgreSQL</a> und <a
        href="https://de.wikipedia.org/wiki/MySQL">MySQL</a>.
    Es besteht das Interesse, Datenbanken unabhängig von der konkreten Realisierung in einem
    Datenbanksystem (DBS) zu modellieren. Für die Modellierung einer Datenbank
    soll es irrelevant sein, wie die Daten intern gespeichert sind. Wir sprechen von <span
        class="bold">Implementierungsunabhängigkeit</span>
</p>
<p>
    Um Anwendungsunabhängigkeit und Implementierungsunabhängigkeit zu erreichen, folgen Datenbanksysteme
    <b>Datenbankarchitekturen</b>, die verschiedene Schichten voneinander
    abgrenzen. Wir betrachten in diesem Modul vor allem die <b>Drei-Schema-Architektur</b>, auch
    <b>ANSI-SPARC-Architektur</b> genannt.
</p>
<h2>ANSI-SPARC-Architektur</h2>
<p>
    Bei der Drei-Schema-Architektur werden drei Schichten unterschieden: die externe Ebene, die
    konzeptionelle Ebene und die interne Ebene.
</p>
<div class="ovk-diagramm">
    <img src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Schichtenarchitektur.svg"
        alt='Es werden drei Schichten übereinander dargestellt und farblich unterschieden. Die oberste grüne Schicht heißt "externe Ebene", darunter
                liegt die konzeptionelle Ebene, darunter die interne Ebene. Rechts neben diesen Ebenen befinden sich nähere Erläuterungen zu den einzelnen
                Ebenen. Rechts neben "externe Ebene" steht der Text "Benutzeroberflächen, Datensichten, API und Schnittstellen". Rechts neben der mittleren Ebene steht
                "Beziehungen und Daten", neben der unteren Ebene steht der Text "Art und Form der Speicherung".' id="er-diagramm" />
</div>
<br />
Die Funktionen dieser Schichten sind im Detail:<br /><br />
<div class="card">
    <div class="card-header">
        <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseOne"
            aria-expanded="true" aria-controls="collapseOne">
            Externe Ebene
        </button>
    </div>
    <div id="collapseOne" class="card-body collapse show">
        <p>
            Zur <span class="bold">externen Ebene</span> gehören im Limo-Shop alle Benutzeroberflächen und Sichten mit
            Datenbezug, also z.&nbsp;B. das Bestellformular oder die Rechnung,
            welche dem Kunden zugestellt wird. Auch die Schnittstellen, die geschaffen werden, damit der
            Großhändler die Produkte automatisiert abrufen kann, gehören zur externen Ebene.
        </p>
    </div>
</div>
<div class="card">
    <div class="card-header">
        <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseTwo"
            aria-expanded="true" aria-controls="collapseTwo">
            Konzeptionelle Ebene
        </button>
    </div>
    <div id="collapseTwo" class="card-body collapse">
        <p>
            Die <b>konzeptionelle Ebene</b> wollen wir in diesem Datenbankmodul betrachten. Dabei lernst du,
            wie eine relationale Datenbank konzeptionell modelliert wird. und dieses Modell in ein
            Relationenmodell überführt werden kann.
        </p>
    </div>
</div>
<div class="card">
    <div class="card-header">
        <button class="btn ovk-expand" data-bs-toggle="collapse" data-bs-target="#collapseThree"
            aria-expanded="true" aria-controls="collapseThree">
            Interne Ebene
        </button>
    </div>
    <div id="collapseThree" class="card-body collapse">
        <p>
            Die <b>interne Ebene</b> (auch physische Ebene), stellt die physische Sicht der Datenbank im
            Computer dar. In ihr wird beschrieben, wie und wo die Daten in der Datenbank gespeichert werden,
            also z.&nbsp;B. das Speichermedium selbst oder das Datenbankprodukt. Muss der Datenbankserver einmal
            &bdquo;umziehen&ldquo; also physisch auf einem anderen Rechner
            installiert werden, soll sich das nicht auf die konzeptionelle Modellierung der Datenbank
            auswirken.
        </p>
    </div>
</div>
<div style="margin-top: 2em;">
    <h2>Übung</h2>
</div>
<iframe title="Datenbanken-Lückentext"
    src="https://ddivideo.inf.tu-dresden.de/wp-admin/admin-ajax.php?action=h5p_embed&id=17" width="900"
    height="550" frameborder="0" allowfullscreen="allowfullscreen"></iframe>
